<?php
add_action('admin_menu', 'dwcm_create_menu');

function dwcm_create_menu(){
    add_submenu_page('options-general.php', 'DW PopUp Card', 'DW PopUp Card', 'administrator', 'dw-popup-card', 'dwcm_settings_page');
    add_action( 'admin_init', 'dwcm_settings_params' );
}

function dwcm_settings_params(){
	$dwcm_settings_array = array(
		// General settings
		'dwcm_card_message',
		'dwcm_snow_effect',
		'dwcm_card_minimize',
		// Card settings
		'dwcm_card_cover',
		'dwcm_card_width',
		'dwcm_card_height',
		'dwcm_card_cover_minimize',
		'dwcm_card_width_minimize',
		'dwcm_card_height_minimize',
		// Style settings
		'dwcm_cover_background',
		'dwcm_message_background',
		'dwcm_text_color',
		'dwcm_link_color',
		'dwcm_font_family',
		'dwcm_font_size',
		'dwcm_custon_style'
	);
	foreach ($dwcm_settings_array as $value) {
		register_setting( 'dwcm-settings-group', $value );
	}
}

function dwcm_settings_page(){
	?>
	<div class="wrap">
		<h2>DW PopUp Card Settings</h2>
		<form method="post" action="options.php">
		    <?php settings_fields( 'dwcm-settings-group' ); ?>
		    <?php do_settings_sections( 'dwcm-settings-group' ); ?>
		    <div id="dwcm-container">
				<h3><?php _e('Message settings','dwcm') ?></h3>
				<table class="form-table">
					<tr valign="top">
						<th scope="row"><?php _e('Card message','dwcm') ?></th>
						<td><?php dwqa_card_message_display() ?></td>
					</tr>
				</table>
				<h3><?php _e('Card settings','dwcm') ?></h3>
				<table class="form-table">
					<tr class="dwcm-snow-effect">
						<th scope="row"><?php _e('Enable snowing effect?','dwcm') ?></th>
						<td>
							<?php 
								$dwcm_snow_effect = get_option('dwcm_snow_effect');
								$dwcm_snow_effect_select = '';
								if ( $dwcm_snow_effect == 'yes' ) $dwcm_snow_effect_select = 'checked';
							?>
							<label style="margin-right: 50px;">
								<input type="radio" name="dwcm_snow_effect" value="no" checked> <?php _e('No','dwcm'); ?> 
							</label>

							<label style="margin-right: 50px;">
								<input type="radio" name="dwcm_snow_effect" value="yes" <?php echo $dwcm_snow_effect_select; ?>> <?php _e('Yes','dwcm'); ?> 
							</label>
						</td>
					</tr>
					<tr class="dwcm-card-minimize">
						<th scope="row"><?php _e('Enable card thumbnail?','dwcm') ?></th>
						<td>
							<?php 
								$dwcm_card_minimize = get_option('dwcm_card_minimize');
								$dwcm_card_minimize_select = '';
								if ( $dwcm_card_minimize == 'yes' ) $dwcm_card_minimize_select = 'checked';
							?>
							<label style="margin-right: 50px;">
								<input type="radio" name="dwcm_card_minimize" value="no" checked> <?php _e('No','dwcm'); ?> 
							</label>

							<label style="margin-right: 50px;">
								<input type="radio" name="dwcm_card_minimize" value="yes" <?php echo $dwcm_card_minimize_select; ?>> <?php _e('Yes','dwcm'); ?> 
							</label>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><?php _e('Card cover','dwcm') ?></th>
						<td><?php dwcm_card_cover_display() ?></td>
					</tr>
					<tr valign="top">
						<th scope="row"><?php _e('Width','dwcm') ?></th>
						<td>
							<input class="small-text" type="text" name="dwcm_card_width" value="<?php echo get_option('dwcm_card_width'); ?>" /> <span class="description"><?php _e('px') ?></span>
						</td>
					</tr>
					<tr>
						<th scope="row"><?php _e('Height','dwcm') ?></th>
						<td>
							<input class="small-text" type="text" name="dwcm_card_height" value="<?php echo get_option('dwcm_card_height'); ?>" /> <span class="description"><?php _e('px') ?></span>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><?php _e('Card thumbnail','dwcm') ?></th>
						<td><?php dwcm_card_cover_minimize_display() ?></td>
					</tr>
					<tr valign="top">
						<th scope="row"><?php _e('Width','dwcm') ?></th>
						<td>
							<input class="small-text" type="text" name="dwcm_card_width_minimize" value="<?php echo get_option('dwcm_card_width_minimize'); ?>" /> <span class="description"><?php _e('px') ?></span>
						</td>
					</tr>
					<tr>
						<th scope="row"><?php _e('Height','dwcm') ?></th>
						<td>
							<input class="small-text" type="text" name="dwcm_card_height_minimize" value="<?php echo get_option('dwcm_card_height_minimize'); ?>" /> <span class="description"><?php _e('px') ?></span>
						</td>
					</tr>
				</table>
				<h3><?php _e('Style settings','dwcm') ?></h3>
				<table class="form-table">
					<tr valign="top">
						<th scope="row"><?php _e('Font size','dwcm') ?></th>
						<td>
							<input class="small-text" type="text" name="dwcm_font_size" value="<?php echo get_option('dwcm_font_size'); ?>" /> <span class="description"><?php _e('px') ?></span>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><?php _e('Font family','dwcm') ?></th>
						<td><?php dwqa_font_family_display() ?></td>
					</tr>
					<tr valign="top">
						<?php
							$dwcm_cover_background = get_option('dwcm_cover_background');
							if ( $dwcm_cover_background == '' ) $dwcm_cover_background = '#bf2928';
						?>
						<th scope="row"><?php _e('Card Cover background','dwcm') ?></th>
						<td><input class="regular-text color_picker dwcm_cover_background" type="text" name="dwcm_cover_background" value="<?php echo $dwcm_cover_background; ?>" /></td>
					</tr>
					<tr valign="top">
						<?php
							$dwcm_message_background = get_option('dwcm_message_background');
							if ( $dwcm_message_background == '' ) $dwcm_message_background = '#fff';
						?>
						<th scope="row"><?php _e('Card Message background','dwcm') ?></th>
						<td><input class="regular-text color_picker dwcm_message_background" type="text" name="dwcm_message_background" value="<?php echo $dwcm_message_background; ?>" /></td>
					</tr>
					<tr valign="top">
						<?php
							$dwcm_text_color = get_option('dwcm_text_color');
							if ( $dwcm_text_color == '' ) $dwcm_text_color = '#333';
						?>
						<th scope="row"><?php _e('Message Text Color','dwcm') ?></th>
						<td><input class="regular-text color_picker dwcm_text_color" type="text" name="dwcm_text_color" value="<?php echo $dwcm_text_color; ?>" /></td>
					</tr>
					<tr valign="top">
						<?php
							$dwcm_link_color = get_option('dwcm_link_color');
							if ( $dwcm_link_color == '' ) $dwcm_link_color = '#bf2928';
						?>
						<th scope="row"><?php _e('Message Link Color','dwcm') ?></th>
						<td><input class="regular-text color_picker dwcm_link_color" type="text" name="dwcm_link_color" value="<?php echo $dwcm_link_color; ?>" /></td>
					</tr>
					<tr valign="top">
						<th scope="row"><?php _e('Custom CSS code','dwcm') ?></th>
						<td>
							<textarea name="dwcm_custon_style" rows="5" cols="100"><?php echo get_option('dwcm_custon_style'); ?></textarea>
						</td>
					</tr>
				</table>
			</div>
		    <?php submit_button(); ?>
		</form>
	</div>
	<?php
}

function dwqa_card_message_display(){
    $dwcm_card_message = get_option('dwcm_card_message');
    $editor_content = isset( $dwcm_card_message ) ? $dwcm_card_message : '';
    wp_editor( $editor_content, 'dwqa_card_message_editor', array(
        'textarea_name' => 'dwcm_card_message'
    ) );
}

function dwcm_card_cover_display(){
    ?>
    <div class="uploader">
        <p> 
        	<input type="text" name="dwcm_card_cover" id="dwcm_card_cover" class="regular-text" 
        		   value="<?php echo  get_option( 'dwcm_card_cover' ); ?>" />
        	<input type="button" class="button" name="dwcm_card_cover_button" id="dwcm_card_cover_button" 
        		   value="<?php _e('Upload','dwcm') ?>" />
        </p>
    </div>
    <script type="text/javascript">
    jQuery(document).ready(function($){
      var _custom_media = true,
          _orig_send_attachment = wp.media.editor.send.attachment;
      $('#dwcm_card_cover_button').click(function(e) {
        var send_attachment_bkp = wp.media.editor.send.attachment;
        var button = $(this);
        var id = button.attr('id').replace('_button', '');
        _custom_media = true;
        wp.media.editor.send.attachment = function(props, attachment){
          if ( _custom_media ) {
            $("#"+id).val(attachment.url);
            if( $( "#"+id ).closest('.uploader').find('.logo-preview').length > 0 ) {
                $( "#"+id ).closest('.uploader').find('.logo-preview img').attr('src', attachment.url);
            }else {
                $( "#"+id ).closest('.uploader').append('<p class="logo-preview"><img src="'+attachment.url+'"></p>')
            }
          } else {
            return _orig_send_attachment.apply( this, [props, attachment] );
          };
        }
        wp.media.editor.open(button);
        return false;
      });
      $('.add_media').on('click', function(){
        _custom_media = false;
      });
    });
    </script>
    <?php
}

function dwcm_card_cover_minimize_display(){
    ?>
    <div class="uploader">
        <p> 
        	<input type="text" name="dwcm_card_cover_minimize" id="dwcm_card_cover_minimize" class="regular-text" 
        		   value="<?php echo  get_option( 'dwcm_card_cover_minimize' ); ?>" />
        	<input type="button" class="button" name="dwcm_card_cover_minimize_button" id="dwcm_card_cover_minimize_button" 
        		   value="<?php _e('Upload','dwcm') ?>" />
        </p>
    </div>
    <script type="text/javascript">
    jQuery(document).ready(function($){
      var _custom_media = true,
          _orig_send_attachment = wp.media.editor.send.attachment;
      $('#dwcm_card_cover_minimize_button').click(function(e) {
        var send_attachment_bkp = wp.media.editor.send.attachment;
        var button = $(this);
        var id = button.attr('id').replace('_button', '');
        _custom_media = true;
        wp.media.editor.send.attachment = function(props, attachment){
          if ( _custom_media ) {
            $("#"+id).val(attachment.url);
            if( $( "#"+id ).closest('.uploader').find('.logo-preview').length > 0 ) {
                $( "#"+id ).closest('.uploader').find('.logo-preview img').attr('src', attachment.url);
            }else {
                $( "#"+id ).closest('.uploader').append('<p class="logo-preview"><img src="'+attachment.url+'"></p>')
            }
          } else {
            return _orig_send_attachment.apply( this, [props, attachment] );
          };
        }
        wp.media.editor.open(button);
        return false;
      });
      $('.add_media').on('click', function(){
        _custom_media = false;
      });
    });
    </script>
    <?php
}

function dwqa_font_family_display(){
    $fonts = dwcm_get_gfonts();
    ?>
	<select name="dwcm_font_family">
		<option value="0"></option>
		<?php foreach($fonts as $font) { 
			$font_value = $font->family.':dw:'.$font->files->regular;
			$selected = '';
			if($font_value == get_option('dwcm_font_family')) {
				$selected = 'selected';
			}
			?>
		<option value="<?php echo $font_value ?>" <?php echo $selected ?>><?php echo $font->family ?></option>
		<?php } ?>
	</select>
    <?php
}