<?php  
/**
 * 	Plugin Name: DW PopUp Card
 * 	Author: DesignWall
 * 	Author URI: http://designwall.com
 * 	Description: Custom pop up card for your Wordpress Site.
 * 	Version: 1.0.0
 *  License: GPLv3
 */

define('DWCM_PATH', plugin_dir_url(__FILE__));
define('DWCM_FOLDER', plugin_dir_path(__FILE__));
include_once DWCM_FOLDER.'dw-popup-card-option.php';

function dwcm_get_option($option_name, $default = ''){
    $options = get_option($option_name);
    if($options != '') return $options;
    return $default;
}

function dwcm_get_gfonts(){
    $fontsSeraliazed = wp_remote_fopen(DWCM_PATH.'assets/font/gfonts_v2.txt');
    $fontArray = unserialize( $fontsSeraliazed );
    return $fontArray->items;
}

function dw_christmas_admin_scripts() {
    wp_enqueue_style('wp-color-picker' );
    wp_enqueue_script('dw-popup-card-admin-script', DWCM_PATH.'assets/js/admin.js', array('wp-color-picker'));
}
add_action('admin_enqueue_scripts','dw_christmas_admin_scripts');

function dw_christmas_enqueue_scripts(){
    if(!wp_script_is('jquery', 'enqueued')) wp_enqueue_script('jquery');
	wp_enqueue_script('dw-popup-card-cookie', DWCM_PATH.'assets/js/jquery.cookie.js', array('jquery'));
	wp_enqueue_script('dw-popup-card-cards', DWCM_PATH.'assets/js/cards.js', array('jquery'));
	wp_enqueue_script('dw-popup-card-script', DWCM_PATH.'assets/js/main.js', array('jquery'));
	wp_enqueue_style('dw-popup-card-style', DWCM_PATH.'assets/css/style.css', array());
}
add_action('wp_enqueue_scripts', 'dw_christmas_enqueue_scripts');

function dw_christmas_markup(){
    $dwcm_options = array();
    $dwcm_options['dwcm_card_message']         = dwcm_get_option('dwcm_card_message');
    $dwcm_options['dwcm_snow_effect']          = dwcm_get_option('dwcm_snow_effect');
    $dwcm_options['dwcm_card_minimize']        = dwcm_get_option('dwcm_card_minimize');
    $dwcm_options['dwcm_card_width']           = dwcm_get_option('dwcm_card_width');
    $dwcm_options['dwcm_card_height']          = dwcm_get_option('dwcm_card_height');
    $dwcm_options['dwcm_card_width_minimize']  = dwcm_get_option('dwcm_card_width_minimize');
    $dwcm_options['dwcm_card_height_minimize'] = dwcm_get_option('dwcm_card_height_minimize');
    $dwcm_options['dwcm_card_cover']           = dwcm_get_option('dwcm_card_cover');
    $dwcm_options['dwcm_card_cover_minimize']  = dwcm_get_option('dwcm_card_cover_minimize');
    $dwcm_options['dwcm_cover_background']     = dwcm_get_option('dwcm_cover_background');
    $dwcm_options['dwcm_message_background']   = dwcm_get_option('dwcm_message_background');
    $dwcm_options['dwcm_text_color']           = dwcm_get_option('dwcm_text_color');
    $dwcm_options['dwcm_link_color']           = dwcm_get_option('dwcm_link_color');
    $dwcm_options['dwcm_font_family']          = dwcm_get_option('dwcm_font_family');
    $dwcm_options['dwcm_font_size']            = dwcm_get_option('dwcm_font_size');
    $dwcm_options['dwcm_custon_style']         = dwcm_get_option('dwcm_custon_style');
	?>
    <style>
        <?php if($dwcm_options['dwcm_card_cover'] != '') { ?>
        .card .dw-popup-card-cover {
            background-image: url(<?php echo $dwcm_options['dwcm_card_cover'] ?>);
        }
        <?php } ?>

        <?php if($dwcm_options['dwcm_card_minimize'] == 'yes' && $dwcm_options['dwcm_card_cover_minimize'] != '') { ?>
        .dw-popup-card-banner a {
            background: url(<?php echo $dwcm_options['dwcm_card_cover_minimize'] ?>);
            height: <?php echo $dwcm_options['dwcm_card_height_minimize'] ?>px;
            width: <?php echo $dwcm_options['dwcm_card_width_minimize'] ?>px;
        }
        <?php } ?>

        <?php if($dwcm_options['dwcm_card_width'] != '' && $dwcm_options['dwcm_card_height'] != '') { ?>
        .dw-popup-card-list li,.dw-popup-card-list li .dw-popup-card-front,.dw-popup-card-list li .dw-popup-card-back,.dw-popup-card-list li .dw-popup-card-front > div {
            width: <?php echo $dwcm_options['dwcm_card_width'] ?>px;
        }
        .dw-popup-card-list li .dw-popup-card-page,.dw-popup-card-list li .dw-popup-card-top,.dw-popup-card-list li .dw-popup-card-bottom {
            width: <?php echo ($dwcm_options['dwcm_card_width'] - 5) ?>px;
        }
        .dw-popup-card-list li .dw-popup-card-page,.dw-popup-card-list li .dw-popup-card-front,.dw-popup-card-list li .dw-popup-card-back,.dw-popup-card-list li .dw-popup-card-front > div,.dw-popup-card-list li .dw-popup-card-left,
        .dw-popup-card-list li .dw-popup-card-card {
            height: <?php echo $dwcm_options['dwcm_card_height'] ?>px;
        }
        .dw-popup-card-list li .dw-popup-card-right {
            height: <?php echo ($dwcm_options['dwcm_card_height'] - 10) ?>px;
        }
        .dw-popup-card-info {
            margin-top: <?php echo ($dwcm_options['dwcm_card_height'] + 1) ?>px;
        }
        <?php } ?>

        <?php if($dwcm_options['dwcm_cover_background'] != '') { ?>
        .card .dw-popup-card-front > div, .card .dw-popup-card-front:after {
            background-color: <?php echo $dwcm_options['dwcm_cover_background'] ?>;
        }
        <?php } ?>

        <?php if($dwcm_options['dwcm_message_background'] != '') { ?>
        .dw-popup-card-content, .dw-popup-card-list li .dw-popup-card-page, .dw-popup-card-list li .dw-popup-card-right, .dw-popup-card-list li .dw-popup-card-top, .dw-popup-card-list li .dw-popup-card-bottom {
            background: <?php echo $dwcm_options['dwcm_message_background'] ?>;
        }
        <?php } ?>

        <?php if($dwcm_options['dwcm_text_color'] != '') { ?>
        .dw-popup-card-content, .dw-popup-card-content p, .dw-popup-card-content div {
            color: <?php echo $dwcm_options['dwcm_text_color'] ?>;
        }
        <?php } ?>

        <?php if($dwcm_options['dwcm_link_color'] != '') { ?>
        .dw-popup-card a {
            color: <?php echo $dwcm_options['dwcm_link_color'] ?>;
        }
        <?php } ?>

        <?php 
        if($dwcm_options['dwcm_font_family'] && $dwcm_options['dwcm_font_family'] != '') {
            $font_family = explode(':dw:', $dwcm_options['dwcm_font_family'] );
            ?>
            @font-face {
                font-family: "<?php echo $font_family[0]; ?>";
                src: url('<?php echo $font_family[1] ?>');
            } 
            .dw-popup-card,.dw-popup-card-content {
                font-family: "<?php echo $font_family[0]; ?>";
            }
        <?php } ?>

        <?php if($dwcm_options['dwcm_font_size'] != '') { ?>
        .dw-popup-card-content, .dw-popup-card-content p, .dw-popup-card-content div {
            font-size: <?php echo $dwcm_options['dwcm_font_size'] ?>px;
        }
        <?php } ?>

        <?php if($dwcm_options['dwcm_snow_effect'] == 'yes') { ?>
        .dw-popup-card {
            background-image: url('<?php echo DWCM_PATH ?>assets/img/snowh.png'), url('<?php echo DWCM_PATH ?>assets/img/snow3q.png'), url('<?php echo DWCM_PATH ?>assets/img/snow2l.png');
            -webkit-animation: snow 20s linear infinite;-moz-animation: snow 20s linear infinite;-ms-animation: snow 20s linear infinite;animation: snow 20s linear infinite;
        }
        <?php } ?>

        <?php if($dwcm_options['dwcm_custon_style'] != '') {
            echo $dwcm_options['dwcm_custon_style'];
        } ?>
    </style>
	<div class="dw-popup-card">
		<a class="dw-popup-card-close" href="javascript:void(0);">
			<img src="<?php echo DWCM_PATH ?>assets/img/close.png" alt="X">
		</a>
        <ul id="dw-popup-card-list" class="dw-popup-card-list clearfix">
            <li>
                <div class="dw-popup-card-card card dw-popup-card-carddefault">
                    <div class="dw-popup-card-front">
                        <div class="dw-popup-card-cover"></div>
                        <div class="dw-popup-card-cover-back"></div>
                    </div>
                    <div class="dw-popup-card-page">
                        <div class="dw-popup-card-content">
                            <?php echo $dwcm_options['dwcm_card_message'] ?>
                        </div>
                    </div>
                    <div class="dw-popup-card-back"></div>
                    <div class="dw-popup-card-right"></div>
                    <div class="dw-popup-card-left"></div>
                    <div class="dw-popup-card-top"></div>
                    <div class="dw-popup-card-bottom"></div>
                </div>
                <div class="dw-popup-card-info"></div>
            </li>
        </ul>
    </div>
    <?php if($dwcm_options['dwcm_card_minimize'] == 'yes') { ?>
    <div class="dw-popup-card-banner"><a href="javascript:void(0);">DW Popup Card</a></div>
    <?php } ?>
    <?php
}
add_action('wp_footer', 'dw_christmas_markup');